#include<cstdio>
#include<set>
#include<algorithm>
#include<vector>
#include<queue>

using namespace std;

#define REP(i,n) for(int i = 0; i < (n); ++i)
#define FOR(i,a,b) for(int i = (a); i < (b); ++i)
#define MP make_pair
#define ST first
#define ND second
#define PB push_back
#define lint long long int
#define max_n 5005

lint GCD(lint a, lint b){
  lint tmp;
  while(b!=0){
    tmp = b;
    b = a%b;
    a = tmp;
  }
  return a;
}

lint eGCD(lint a,lint b, lint& x, lint& y){
  if(b==0){
    x = 1LL; y = 0LL;
    return a;
  }
  lint d = eGCD(b,a%b,y,x);
  y = a-x*(a/b)-y;
  x=b-x;
  return d;
}

lint inverse(lint a,lint p){ lint x,y; eGCD(a%p+p,p,x,y); return x%p;}

bool crt_error;

lint CRT(lint a,lint m, lint b, lint n){
  b = (b+n-(a%n))%n;
  lint d = GCD(m,n);
  if(b%d!=0){
    crt_error = true;
    return 0;
  }
  lint old_m = m;
  m/=d; b/=d; n/=d;
  return ((b*inverse(m,n)%n))*old_m +a;
}

int n;
int next[max_n];
int st[max_n];
int liczby[6];
int dl[6];
int mini[max_n][10];

int main(){
  while(1){
    scanf("%d",&n);
    if(!n) return 0;
    FOR(i,1,5*n+1) scanf("%d",&st[i]);
    
    FOR(i,1,2*n+1) next[i] = ((i-1)/2) *5 + (i-1)%2 +1;
    FOR(i,2*n+1,4*n+1) next[i] = next[i-2*n]+2;
    FOR(i,4*n+1,5*n+1) next[i] = (i-4*n)*5;
    
    int x=0; FOR(i,1,5*n+1) if(st[i]<6) liczby[x++]=i;
    
    FOR(i,1,5*n+1) FOR(j,0,5) mini[i][j]=-1;
    
    FOR(i,0,5){
      int dlcyklu=1;
      int cos = next[liczby[i]];
      mini[liczby[i]][i]=0;
      while(cos!=liczby[i]){
        dlcyklu++;
        mini[cos][i]=dlcyklu;
        cos = next[cos];
      }
      dl[i] = dlcyklu;
    }
    printf("DUPA\n");
    lint best = -1; int dla = -1;
    FOR(i,0,n){
      
      int perm[6]; FOR(j,0,5) perm[i]=i;
      // sprawdzam gosci o numerach 5i+1,...,5i+5
      do{
        crt_error = false;
        lint modulus;
        lint x = CRT( mini[5*i+1][perm[0]] , dl[perm[0]], mini[5*i+2][perm[1]], dl[perm[1]]);
        if( crt_error) continue;
        modulus = dl[perm[0]]*dl[perm[1]]/GCD(dl[perm[0]],dl[perm[1]]);
        
        x = CRT( x, modulus, mini[5*i+3][perm[2]],dl[perm[2]]);
        if(crt_error) continue;
        modulus = modulus* dl[perm[2]] / GCD(modulus, dl[perm[2]]);
        
        x = CRT( x, modulus, mini[5*i+4][perm[3]],dl[perm[3]]);
        if(crt_error) continue;
        modulus = modulus* dl[perm[3]] / GCD(modulus, dl[perm[3]]);
        
        x = CRT( x, modulus, mini[5*i+5][perm[4]],dl[perm[4]]);
        if(crt_error) continue;
        modulus = modulus* dl[perm[4]] / GCD(modulus, dl[perm[4]]);
        
        if(best==-1){
          best = x; dla = i;
        }
        else if(best>x){
          best = x; dla = i;
        }
        
      }while(next_permutation(perm,perm+5));
    }
      if(best==-1) printf("Neverending game.\n");
      else printf("Player %d wins game number %lld.\n",dla,best);
      
      
    }
}